package com.neomind.fusion.custom.portoitapoa.rto;


import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.neomind.fusion.common.NeoObject;
import com.neomind.fusion.custom.portoitapoa.PortoItapoaUtils;
import com.neomind.fusion.entity.EntityWrapper;
import com.neomind.fusion.workflow.Activity;
import com.neomind.fusion.workflow.Task;
import com.neomind.fusion.workflow.adapter.AdapterInterface;
import com.neomind.fusion.workflow.adapter.AdapterUtils;
import com.neomind.fusion.workflow.adapter.CheckPointUtils;
import com.neomind.util.NeoUtils;

public class ValidaAnaliseDepartamentos implements AdapterInterface{

	private static final Log log = LogFactory.getLog(ValidaAnaliseDepartamentos.class);
	
	@Override
	public void start(Task origin, EntityWrapper processEntity,
			Activity activity) {
		log.debug("1 START - Checkpoint Finish");
		
		Task task = PortoItapoaUtils.getTaskOrigin(activity);

		NeoObject eform = task.getProcessEntity();
		EntityWrapper subProcessEntity = new EntityWrapper(eform);
		
		//Mudar validacao quando for possivel testar com origin
		if(!task.getActivityName().contains("Gestor Área Analise Registro")
				&& !task.getActivityName().contains("Descrever Ação Imediata"))
		{
			log.debug("Entrou no Retorno da análise - " + task.getActivityName());
			if(NeoUtils.safeIsNull(processEntity.findGenericValue("respostaSupervisoresEnvolvidos")))
			{
				log.debug("respostaSupervisoresEnvolvidos == null");
				processEntity.findField("respostaSupervisoresEnvolvidos").setValue(AdapterUtils.createNewEntityInstance("respostaSupervisoresEnvolvidos"));
			}
			
			NeoObject resposta = processEntity.findGenericValue("respostaSupervisoresEnvolvidos");
			EntityWrapper wpResposta = new EntityWrapper(resposta);
			
			List<NeoObject> listaPatrimonial = (List<NeoObject>) subProcessEntity.findGenericValue("tratamentoPatrimonial");
			List<NeoObject> listaAmbiental = (List<NeoObject>) subProcessEntity.findGenericValue("tratamentoAmbiental");
			List<NeoObject> listaPessoal = (List<NeoObject>) subProcessEntity.findGenericValue("tratamentoPessoal");

			//TRATAMENTO PATRIMONIAL
			if(wpResposta.findField("tratamentoPatrimonial") != null)
			{				
				for (NeoObject item : listaPatrimonial)
				{										
					wpResposta.findField("tratamentoPatrimonial").addValue(item);
				}
			}
			else
			{
				wpResposta.findField("tratamentoPatrimonial").setValue(listaPatrimonial);
			}
			
			//TRATAMENTO AMBIENTAL
			if(wpResposta.findField("tratamentoAmbiental").getValue() != null)
			{				
				for (NeoObject item : listaAmbiental)
				{										
					wpResposta.findField("tratamentoAmbiental").addValue(item);
				}
			}
			else
			{
				wpResposta.findField("tratamentoAmbiental").setValue(listaAmbiental);
			}
			
			//TRATAMENTO PESSOAL
			if(wpResposta.findField("tratamentoPessoal").getValue() != null)
			{				
				for (NeoObject item : listaPessoal)
				{										
					wpResposta.findField("tratamentoPessoal").addValue(item);
				}
			}
			else
			{
				wpResposta.findField("tratamentoPessoal").setValue(listaPessoal);
			}
		}
		log.debug("END - Checkpoint Finish");

		new CheckPointUtils().checkFinish(processEntity, activity, "listaAnaliseDepartamento", "Análise de Departamento");
	}

	@Override
	public void back(EntityWrapper processEntity, Activity activity) {
		// TODO Auto-generated method stub
		
	}
}
